<template>
  <form @submit.prevent="deleteItem">
    <AtomAlert
      class="fr-mb-2w"
      :alert-type="AlertType.Warning"
      message="Toute suppression est définitive."
      :detailed-message="detailedMessage"
    />
    <p>Souhaitez-vous confirmer la suppression ou annuler ?</p>
    <ul class="fr-btns-group fr-btns-group--inline-md fr-mt-3w">
      <li>
        <button
          class="fr-btn"
          title="Annuler"
          type="button"
          @click="$modal.close"
        >
          Annuler
        </button>
      </li>
      <li>
        <button
          class="fr-btn btn-delete-action"
          title="Supprimer"
          type="submit"
          :submitting="isSubmitting"
        >
          Supprimer
        </button>
      </li>
    </ul>
  </form>
</template>

<script setup lang="ts">
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { AlertType } from '~/utils/constants/alert'

  const { $deleteItem, $snackbar, $modal } = useNuxtApp()

  const props = withDefaults(
    defineProps<{
      itemId: string
      collection: string
      detailedMessage?: string
    }>(),
    { detailedMessage: '' }
  )

  const emit = defineEmits<{ (e: 'deleted'): void }>()

  const isSubmitting = ref(false)

  async function deleteItem() {
    isSubmitting.value = true
    try {
      const res = await $deleteItem(props.collection, props.itemId)

      if (res.ok) {
        emit('deleted')
        $modal.close()
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error('La suppression a échoué.')
    } finally {
      isSubmitting.value = false
    }
  }
</script>
